Subject: bug#47320: Improve failure reporting in test/lisp/electrict-tests.el

From: João Távora <[email-masked]>
Date: Wed, 24 Mar 2021 14:02:58 +0000

Hello Alan,

On Wed, Mar 24, 2021 at 1:46 PM Alan Mackenzie <[email-masked]> wrote:

> Thanks for the positive reaction!

Speak nothing of it!

> I'm having some difficulty getting my head around the "explanation"
> functionality of ert, which leans me towards my initial plan.
>
> Here's the patch (actually written quite a long time ago) I would like to
> merge into electric-tests.el:

As far as I understand, this just stores the big explanation string in
a variable, and uses it both for putting into the `ert-deftest` 's docstring
as well as for logging with message(), right?  If so, it's fine to add.

Maybe you could leverage `ert-fail` instead of checking the test's
main assertion twice, once in should, and once when deciding
whether to log.

I'd say, just check it once and put both logging and `ert-fail` inside the if.

João